; 1.0 states

;---------------------------------------------------------------------------
; Stand to Crouch
[Statedef 10]
type    = C
physics = C
anim = 10

[State 10, 1]
type = VelMul
trigger1 = Time = 0
x = .75

[State 10, 2] ;Stop moving if low velocity
type = VelSet
trigger1 = abs(vel x) < Const(movement.crouch.friction.threshold)
x = 0

[State 10, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 11

;---------------------------------------------------------------------------
; Crouching
[Statedef 11]
type    = C
physics = C
anim = 11
sprpriority = 0

[State 11, 1] ;Change from turning animation
type = ChangeAnim
trigger1 = Anim = 6 && AnimTime = 0
value = 11

[State 11, 2] ;Stop moving if low velocity
type = VelSet
trigger1 = abs(vel x) < Const(movement.crouch.friction.threshold)
x = 0

;---------------------------------------------------------------------------
; Tripped get-hit (knocked away)
[Statedef 5071]
type    = A
movetype= H
physics = N

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
sysvar(0) = 0

[State 5071, 1]
type = HitVelSet
trigger1 = Time = 0
x = 1
y = 1

[State 5071, 2] ;Acceleration
type = VelAdd
trigger1 = time > 0
y = GetHitVar(yaccel)

[State 5071, 3] ;Hit ground
trigger1 = Vel Y > 0
trigger1 = Pos Y >= Const(movement.air.gethit.trip.groundlevel)
type = ChangeState
value = 5110

;---------------------------------------------------------------------------
;Thrown by Kung Fu Throw - thrown into the air
[Statedef 851]
type    = A
movetype= H
physics = N
velset = 0,0;-4,-11.11

[State 0, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 1,0
ignorehitpause = 1

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = 0-const(size.mid.pos.x)
y = 0-const(size.mid.pos.y)

[State 0, VelAdd]
type = VelSet
trigger1 = time = 0
x = 5.10245
y = 14.21957 * (4.0/3.0) * 1.07

[State 0, VelAdd]
type = VelAdd
trigger1 = time
y = 0.5625 * (16.0/9.0) * 1.07


[State 5100, 7]
type = ChangeState
;triggerall = time >= 12
trigger1 = vel y > 0
trigger1 = vel y + pos y >= Const(movement.air.gethit.groundlevel)
value = 852



;---------------------------------------------------------------------------
; Downed get-hit (bounce off ground)
[Statedef 853]
type    = L
movetype= H
physics = N

[State 5101, 1] ;Coming hit ground anim (normal)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim != [5101,5109]
trigger2 = !SelfAnimExist(5160 + (anim % 10))
value = 5160

[State 5101, 2] ;Coming hit ground anim (for hit up)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim = [5101,5109]
trigger1 = SelfAnimExist(5160 + (anim % 10))
value = 5160 + (anim % 10)

[State 0, VelSet]
type = VelSet
trigger1 = time = 0
x = 4.71404
y = -5.656855 * (4.0/3.0)

[State 5101, 4]
type = PosSet
trigger1 = Time = 0
y = Const(movement.down.bounce.offset.y)

[State 5101, 5]
type = PosAdd
trigger1 = Time = 0
x = Const(movement.down.bounce.offset.x)

[State 5101, 6] ;Acceleration
type = VelAdd
trigger1 = time > 0
y = 0.5625 * (16.0/9.0) * 1.07;Const(movement.down.bounce.yaccel)

[State 5101, 7] ;Hit ground
trigger1 = Vel Y > 0
trigger1 = Pos Y >= Const(movement.down.bounce.groundlevel)
type = SelfState
value = 5110

;------------------
; Hit by Fast Kung Fu Palm - flying through the air
; (a custom gethit state)
[Statedef 226]
type    = A
movetype= H
physics = N

[State 1026, Velocity]
type = HitVelSet
trigger1 = Time = 0
x = 1
y = 1

[State 1026, Gravity]
type = VelAdd
trigger1 = 1
y = gethitvar(yaccel);.88

[State 1026, No scroll]
type = ScreenBound
triggerall = Pos y < -15
trigger1 = BackEdgeBodyDist < 65
trigger2 = FrontEdgeBodyDist < 65
value = 1
movecamera = 0,1

[State 1026, Hit wall]
type = ChangeState
triggerall = Pos y < -15
trigger1 = BackEdgeBodyDist <= 20
trigger2 = FrontEdgeBodyDist <= 20
value = 227

[State 1026, Hit ground]
type = SelfState
trigger1 = (Vel y > 0) && (Pos y >= Const(movement.air.gethit.groundlevel))
value = 5100

;------------------
; Hit by Fast Kung Fu Palm - hit wall
; (a custom gethit state)
[Statedef 227]
type    = A
movetype= H
physics = N
velset = 0,0

;[State 1027, Sound]
;type = PlaySnd
;trigger1 = Time = 0
;value = F7,0

[State 1027, Anim]
type = ChangeAnim2
trigger1 = Time = 0
value = 227

[State 1027, Turn]
type = Turn
trigger1 = (Time = 0) && (FrontEdgeBodyDist <= 30)

[State 1027, Pos]
type = PosAdd
trigger1 = Time = 0
x = 0 - BackEdgeBodyDist

[State 1027, Stop moving]
type = PosFreeze
trigger1 = animelemtime(7) < 0
x = 1
y = 1

[State 1027, No scroll]
type = ScreenBound
trigger1 = animelemtime(7) < 0
value = 1
movecamera = 0,1

;[State 1027, Spark]
;type = Explod
;trigger1 = Time = 0
;anim = F72
;pos = 0, floor (screenpos y) - 50
;postype = back
;sprpriority = 3

[State 1028, Gravity]
type = VelSet
trigger1 = animelemtime(7) = 0
x = 1.372
y = -14.971

;[State 1028, Gravity]
;type = VelSet
;trigger1 = animelemtime(7) = 0
;trigger1 = animelemtime(8) < 0
;x = vel x + 0.29

[State 1028, Gravity]
type = VelSet
trigger1 = animelemtime(7) > 0
;x = vel x; + 0.09
y = vel y+gethitvar(yaccel)

[State 1028, Hit ground]
type = SelfState
trigger1 = animelemtime(7) >= 0
trigger1 = (Vel y > 0) && (Pos y >= Const(movement.air.gethit.groundlevel))
value = 5100

;---------------------------------------------------------------------------
; Air get-hit (knocked away)
[Statedef 501]
type    = A
movetype= H
physics = N
ctrl = 0

[State 5020, 2] ;Anim for HIT_BACK
type = ChangeAnim
triggerall = anim != 5070
trigger1 = Time = 0
trigger1 = hitfall
trigger1 = GetHitVar(animtype) = [3,5]
value = 5030

[State 5020, 3] ;Anim for HIT_UP/HIT_DIAGUP (only if it exists)
type = ChangeAnim
triggerall = anim != 5070
trigger1 = Time = 0
trigger1 = (GetHitVar(animtype) = [4,5]) && (SelfAnimExist(5047 + GetHitVar(animtype)))
value = 5047 + GetHitVar(animtype) ;5051 - 4 + type

[State 5030, 1]
type = ChangeAnim
triggerall = anim != 5070
trigger1 = vel x = 0
trigger1 = SelfAnimExist(5051)
trigger1 = anim != 5051
value = 5051

;[State 5030, 1]
;type = ChangeAnim
;trigger1 = Anim != [5000, 5199]
;trigger1 = SelfAnimExist(ifelse(vel x=0,5051,5030))
;value = SelfAnimExist(ifelse(vel x=0,5051,5030))

[State 5030, 2]
type = VelAdd
trigger1 = time > 0
y = GetHitVar(yaccel)

[State 5030, 3]
type = HitVelSet
trigger1 = Time = 0
x = 1
y = 1

[State 5030, 4]
type = SelfState
triggerall = !HitFall
trigger1 = HitOver && (time>gethitvar(hittime)) 
trigger2 = Vel Y > 0    ;Hit ground
trigger2 = Pos Y >= 10;Const(movement.air.gethit.groundlevel)
value = 5040 ;HITA_RECOV

[State 5030, 5]
type = SelfState
triggerall = HitFall
trigger1 = Vel Y > 0    ;Hit ground
trigger1 = Pos Y >= Const(movement.air.gethit.groundlevel)
value = 5100 ;HITA_FALL

[State 5030, 6]
type = ChangeState
trigger1 = AnimTime = 0
value = 502 ;Air get-hit (transition)

;---------------------------------------------------------------------------
; Air get-hit (transition)
[Statedef 502]
type    = A
movetype= H
physics = N

[State 5035, 1]
type = ChangeAnim
trigger1 = anim != 5070
trigger1 = Time = 0
trigger1 = Anim != 5090 ;Not if hit off ground anim
value = ifelse(selfanimexist(5061),5061,ifelse(selfanimexist(5030),5030,5050))
[State 5035, 1]
type = ChangeAnim
trigger1 = anim != 5070
trigger1 = animTime = 0
trigger1 = Anim = 5030 ;Not if hit off ground anim
value = ifelse(selfanimexist(5035),5035,5050)
[State 5035, 1]
type = ChangeAnim
trigger1 = anim != 5070
trigger1 = animTime = 0
trigger1 = Anim = 5035 ;Not if hit off ground anim
value = 5050

[State 5035, 2]
type = VelAdd
trigger1 = time > 0
y = GetHitVar(yaccel)

[State 5035, 3]
type = SelfState
triggerall = !HitFall
trigger1 = HitOver && (time>gethitvar(hittime)) 
trigger2 = Vel Y > 0    ;Hit ground
trigger2 = Pos Y >= 10;Const(movement.air.gethit.groundlevel)
value = 5040 ;Air get-hit (recovering in air, not falling)

[State 5035, 4]
type = SelfState
triggerall = HitFall
trigger1 = Vel Y > 0    ;Hit ground
trigger1 = Pos Y >= Const(movement.air.gethit.groundlevel)
;trigger2 = Time = 0     ;No transition anim
;trigger2 = Anim != 5061
value = 5100 ;Air get-hit (falling)


; Launched
[Statedef 511]
type    = A
movetype= H
physics = N
juggle  = 0
ctrl = 0

[State 0, PosAdd]
type = PosAdd
trigger1 = time = 0
x = 0
y = -11

[State 0, HitVelSet]
type = HitVelSet
trigger1 = time = 0
x = 1
y = 1
[State 0, VelSet]
type = VelSet
trigger1 = time > 0
y = vel y + gethitvar(yaccel)

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = anim != 5160
trigger1 = anim != ifelse(selfanimexist(5051),5051,5050)
value = ifelse(selfanimexist(5051),5051,5050)

[State 0, SelfState]
type = SelfState
trigger1 = time >= 17; hitover && time >= gethitvar(hittime)
trigger2 = time
trigger2 = vel y > 0
trigger2 = vel y + pos y >= -64;-80;-68;Const(movement.air.gethit.groundlevel)
value = ifelse(alive,5040,5050)
;ctrl = ifelse(alive,1,0)

;---------------------------------------------------------------------------
; Tripped get-hit (shaking)
[Statedef 570]
type    = A
movetype= H
physics = N
velset = 0,0

[State 0, PosSet]
type = PosSet
trigger1 = time = 0
trigger1 = pos y > 0
y = 0
ignorehitpause = 1

[State 0, NotHitBy]
type = NotHitBy
trigger1 = time = 0
trigger1 = name != "Dhalsim"
trigger1 = name != "Dhalsims"
trigger1 = name != "cvsDhalsim"
trigger1 = name != "RaajaDhalsim"
value = ,AA,AP,AT
time = 14
ignorehitpause = 1


[State 5070, 1]
type = ChangeAnim
trigger1 = time = 0
value = 5010
[State 5020, 4]
type = ChangeAnim
trigger1 = Time = 0
value = anim
elem = animelemno(2)
[State 5020, 4]
type = ChangeAnim
trigger1 = Time
value = anim
elem = animelemtime(0)

[State 5070, 2]
type = ChangeState
trigger1 = HitShakeOver
value = 571

[State 5070, 3]
type = ForceFeedback
trigger1 = time = 0
time = 12
waveform = sinesquare
ampl = 140

; Shadow and Timer
[Statedef 722]
type    = A
movetype= I
physics = N
juggle  = 0
anim = 9741
velset = 0,0
ctrl = 0
sprpriority = -8

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = 1
flag = noshadow
ignorehitpause = 1

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = parent,anim = 810
trigger2 = !selfanimexist(parent,anim)
trigger3 = parent,movetype = H
flag = invisible
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
var(0) = parent,var(59)
[State 0, VarSet]
type = ParentVarSet
trigger1 = time = 0
var(59) = -3
[State 0, VarSet]
type = ParentVarSet
trigger1 = time = 0
fvar(13) = 1.4 + (0.1*var(0))
[State 0, VarSet]
type = ParentVarSet
trigger1 = time = 0
fvar(16) = 300 + (120*var(0))

[State 0, NotHitBy]
type = NotHitBy
trigger1 = time >= 0
value = ,AA,AP,AT
time = 2
ignorehitpause = 1

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = selfanimexist(parent,anim)
trigger1 = parent,movetype != H
value = parent,anim
elem = parent,animelemno(0)
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(0) = 1+(cos(time*.123))
ignorehitpause = 1

[State 0, Turn]
type = Turn
trigger1 = facing != parent,facing

[State 0, PosAdd]
type = PosAdd
trigger1 = time >= 0
x = parentdist x
y = parentdist y+(fvar(0)*2.5);(cos(time*.1)*1)

[State 0, Offset]
type = Offset
triggerall = parent,stateno = 422
triggerall = parent,fvar(0) < 0
trigger1 = parent,animelemtime(5) >= 0
trigger1 = parent,animelemtime(9) < 0
x = 0
y = parent,fvar(0)
ignorehitpause = 1

[State 0, Trans]
type = Trans
trigger1 = time >= 0
trans = add1
ignorehitpause = 1

[State 0, PalFXWiz]
type = PalFX
trigger1 = time >= 0
time = 2
add = 64+floor(sin(time*.1)*32 ),0,0
mul = 512,0,0
invertall = 0
color = 0

[State 0, AngleDraw]
type = AngleDraw
trigger1 = time >= 0
value = 0
scale = 1+(fvar(0)*0.05),1+(fvar(0)*0.05)
;scale = 1+(cos(time*.1)*.1),1+(cos(time*.1)*.1)
ignorehitpause = 1

[State 0, PlaySnd]
type = PlaySnd
trigger1 = time = 0
value = S0,33
abspan = 0
[State 0, PlaySnd]
type = PlaySnd
trigger1 = time = 0
value = S0,40
abspan = 0
[State 0, PlaySnd]
type = PlaySnd
triggerall = numexplod(725)
trigger1 = parent,fvar(16) = [1,180]
value = S0,38
abspan = 0
persistent = 0
[State Waagh]
type = PlaySnd
trigger1 = parent,movetype = A
trigger1 = parent,time = 1
trigger2 = parent,stateno = 1020
trigger2 = parent,anim = 1020
trigger2 = parent,animelem = 2
value = S0,39
abspan = 0
channel = 0

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
fvar(7) = 1
[State 0, VarSet]
type = VarSet
trigger1 = time
fvar(7) = fvar(7) * 0.9

[State 0, VarSet]
type = VarSet
trigger1 = time >= 0
fvar(8) = parent,fvar(16)
[State 0, VarSet]
type = VarSet
trigger1 = time >= 0
fvar(9) = 300 + (120*var(0))

[State 0, Explod]
type = Explod
trigger1 = time = 0
anim = 724
ID = 724
pos = ifelse(teamside=1,50,270)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .5,.5
sprpriority = 80
ontop = 1
ownpal = 1
ignorehitpause = 1
[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(724)
ID = 724
pos = ifelse(teamside=1,50,270)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .5,.5
sprpriority = 80
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, Explod]
type = Explod
trigger1 = time = 0
anim = 725
ID = 725
pos = ifelse(teamside=1,32,288)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = 1,1;.5,.5
sprpriority = 83
ontop = 1
ownpal = 1
ignorehitpause = 1
[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(725)
ID = 725
pos = ifelse(teamside=1,32,288)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = 1,1;.5,.5
sprpriority = 83
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, Explod]
type = Explod
trigger1 = time = 0
anim = 726
ID = 726
pos = ifelse(teamside=1,32,288)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = (fvar(8)/fvar(9)),1; .5*(fvar(8)/fvar(9)) ,.5
sprpriority = 84
ontop = 1
ownpal = 1
ignorehitpause = 1
[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(726)
ID = 726
pos = ifelse(teamside=1,32,288)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = (fvar(8)/fvar(9)),1;.5*(fvar(8)/fvar(9)) ,.5
sprpriority = 84
ontop = 1
ownpal = 1
ignorehitpause = 1

;[State 0, RemoveExplod]
;type = RemoveExplod
;triggerall = numexplod(725)
;trigger1 = parent,fvar(16)<= 0
;trigger2 = roundstate >= 4
;id = 724

;[State 0, RemoveExplod]
;type = RemoveExplod
;triggerall = numexplod(725)
;trigger1 = parent,fvar(16)<= 0
;trigger2 = roundstate >= 4
;id = 725

;[State 0, RemoveExplod]
;type = RemoveExplod
;triggerall = numexplod(726)
;trigger1 = parent,fvar(16)<= 0
;trigger2 = roundstate >= 4
;id = 726

[State 0, DestroySelf]
type = ChangeState;DestroySelf
triggerall = time
trigger1 = parent,fvar(16)<= 0
trigger2 = roundstate >= 4
value = 723
;trigger1 = !numexplod(724)
;trigger1 = !numexplod(725)
;trigger1 = !numexplod(726)
;trigger1 = time >= 300 + (120*var(0))
;trigger2 = roundstate >= 4
;trigger1 = time >= 360 + (180*var(0))

; Let's fade it out boys
[Statedef 723]
type    = A
movetype= I
physics = N
juggle  = 0
velset = 0,0
anim = 9741
ctrl = 0
sprpriority = -8

[State 0, NotHitBy]
type = NotHitBy
trigger1 = time >= 0
value = ,AA,AP,AT
time = 2
ignorehitpause = 1

[State 0, PlaySnd]
type = PlaySnd
trigger1 = time = 0
value = S0,41
abspan = 0
channel = 0

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
fvar(0) = 1
[State 0, VarSet]
type = VarSet
trigger1 = time >= 0
fvar(0) = ifelse(fvar(0)-0.1<=0,0,fvar(0)-0.1)

[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(724)
ID = 724
pos = ifelse(teamside=1,50,270)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = .5*fvar(0),.5+(1-fvar(0))
sprpriority = 80
ontop = 1
ownpal = 1
ignorehitpause = 1

[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(725)
ID = 725
pos = ifelse(teamside=1,32,288)-ceil(80*fvar(7)*ifelse(teamside=1,1,-1)),gameheight+ceil(parent,fvar(32))
postype = left
facing = ifelse(teamside=1,1,-1)
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
pausemovetime = 65535
supermovetime = 65535
scale = 1,1*fvar(0)
sprpriority = 83
ontop = 1
ownpal = 1
ignorehitpause = 1



[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(725)
trigger1 = fvar(0) <= 0
id = 724

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = numexplod(725)
trigger1 = fvar(0) <= 0
id = 725

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(726)
id = 726

[State 0, DestroySelf]
type = DestroySelf
triggerall = time
trigger1 = !numexplod(724)
trigger1 = !numexplod(725)
trigger1 = !numexplod(726)
;trigger1 = time >= 300 + (120*var(0))
;trigger2 = roundstate >= 4
;trigger1 = time >= 360 + (180*var(0))

;---------------------------------------------------------------------------
;Thrown by Kung Fu Throw - thrown into the air
[Statedef 1056]
type    = A
movetype= H
physics = N
velset = 0,0;-4,-11.11

[State 0, VelAdd]
type = VelSet
trigger1 = time = 12
x = -10.47063
y = -4.51699 *  1.07

[State 0, VelAdd]
type = VelAdd
trigger1 = time > 12
y = 0.5625 * (16.0/9.0) * 1.07

[State 5100, 2]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(selfanimexist(5052),5052,5030)
[State 5100, 2]
type = ChangeAnim
trigger1 = time < 12
value = anim
[State 5100, 2]
type = ChangeAnim
triggerall = time >= 12
trigger1 = anim = [5030,5039]
trigger1 = animtime = 0
value = ifelse(anim=5030&&selfanimexist(5035),5035,5050)

[State 821, 2] ; Recover near ground (use ChangeState)
type = ChangeState
triggerall = time >= 12
triggerall = Vel Y > 0
triggerall = Pos Y >= const(movement.air.gethit.groundrecover.ground.threshold)
triggerall = alive
triggerall = CanRecover
trigger1 = Command = "recovery"
value = 5200 ;HITFALL_RECOVER


[State 5100, 7]
type = SelfState
triggerall = time >= 12
trigger1 = vel y > 0
trigger1 = vel y + pos y >= Const(movement.air.gethit.groundlevel)
value = 5100 ;HIT_LIEDOWN

;---------------------------------------------------------------------------
; Downed get-hit (bounce off ground)
[Statedef 1107]
type    = L
movetype= H
physics = N

[State 5101, 1] ;Coming hit ground anim (normal)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim != [5101,5109]
trigger2 = !SelfAnimExist(5160 + (anim % 10))
value = 5160

[State 5101, 2] ;Coming hit ground anim (for hit up)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim = [5101,5109]
trigger1 = SelfAnimExist(5160 + (anim % 10))
value = 5160 + (anim % 10)

;[State 5101, 3]
;type = HitFallVel
;trigger1 = Time = 0

[State 0, VelSet]
type = VelSet
trigger1 = time = 0
x = -4.71404
y = -5.656855 * (4.0/3.0)

[State 5101, 4]
type = PosSet
trigger1 = Time = 0
y = Const(movement.down.bounce.offset.y)

[State 5101, 5]
type = PosAdd
trigger1 = Time = 0
x = Const(movement.down.bounce.offset.x)

[State 5101, 6] ;Acceleration
type = VelAdd
trigger1 = time > 0
y = 0.5625 * (16.0/15.0) * 1.07;Const(movement.down.bounce.yaccel)

[State 5101, 7] ;Hit ground
trigger1 = Vel Y > 0
trigger1 = Pos Y >= Const(movement.down.bounce.groundlevel)
type = SelfState
value = 5110

;---------------------------------------------------------------------------
; Downed get-hit (bounce off ground)
[Statedef 3227]
type    = L
movetype= H
physics = N

[State 5101, 1] ;Coming hit ground anim (normal)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim != [5101,5109]
trigger2 = !SelfAnimExist(5160 + (anim % 10))
value = 5160

[State 5101, 2] ;Coming hit ground anim (for hit up)
type = ChangeAnim
triggerall = time = 0
trigger1 = anim = [5101,5109]
trigger1 = SelfAnimExist(5160 + (anim % 10))
value = 5160 + (anim % 10)

;[State 5101, 3]
;type = HitFallVel
;trigger1 = Time = 0

[State 0, VelSet]
type = VelSet
trigger1 = time = 0
x = 4.71404
y = -5.656855 * (4.0/3.0)

[State 5101, 4]
type = PosSet
trigger1 = Time = 0
y = Const(movement.down.bounce.offset.y)

[State 5101, 5]
type = PosAdd
trigger1 = Time = 0
x = Const(movement.down.bounce.offset.x)

[State 5101, 6] ;Acceleration
type = VelAdd
trigger1 = time > 0
y = 0.5625 * (16.0/15.0) * 1.07;Const(movement.down.bounce.yaccel)

[State 5101, 7] ;Hit ground
trigger1 = Vel Y > 0
trigger1 = Pos Y >= Const(movement.down.bounce.groundlevel)
type = SelfState
value = 5110

;---------------------------------------------------------------------------
; Hyper BG
[Statedef 2991]
type    = A
movetype= I
physics = N
ctrl = 0
anim = 9741
sprpriority = 5
velset = 0,0

[State 0, PosSet]
type = PosSet
trigger1 = time = 0
y = 0
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(0) = ifelse((screenpos y)-212<0,0,(screenpos y)-212)
[State 0, VarSet]
type = VarSet
trigger1 = 1
fvar(1) = 1+(fvar(0)/212)

[State 0, DisplayToClipboard]
type = DisplayToClipboard
trigger1 = 1
text = "y = %f pos = %f, ska = %f"
params = screenpos y,fvar(0),fvar(1)
ignorehitpause = 1


[State 0, Explod]
type = Explod
trigger1 = time = 0
anim = 2995
ID = 2995
pos = 0,0
postype = left
facing = 1
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -1
scale = .5,.5*fvar(1)
sprpriority = -999
ontop = 0
shadow = 0,0,0
ownpal = 0
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, Explod]
type = ModifyExplod
trigger1 = numexplod(2995)
ID = 2995
scale = .5,.5*fvar(1)
ignorehitpause = 1

[State 0, ChangeState]
type = ChangeState
triggerall = time
;triggerall = numexplod(2995)
triggerall = winko
trigger1 = root,stateno = 3011
trigger2 = root,stateno = 3021
trigger3 = root,stateno = 3110
trigger4 = root,stateno = 3211
trigger5 = root,stateno = 3260
value = ifelse((root,command="holdstart")||(enemynear,command="holdstart"),2993,2992)
;value = ifelse((root,command="holdstart"),2993,2992)
ctrl = 0
ignorehitpause = 1

[State 0, RemoveExplod]
type = RemoveExplod
triggerall = time
triggerall = numexplod(2995)
triggerall = !winko
trigger1 = root,stateno != 3000
trigger1 = root,stateno != 3100
trigger1 = root,stateno != 3101
trigger1 = root,stateno != 3200
trigger1 = root,stateno != 3300
trigger1 = root,stateno != 3011
trigger1 = root,stateno != 3021
trigger1 = root,stateno != 3110
trigger1 = root,stateno != 3210
trigger1 = root,stateno != 3211
trigger1 = root,stateno != 3260
trigger2 = root,stateno = 3000
trigger2 = root,movetype = I
id = 2995
ignorehitpause = 1

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = numexplod(2995)
ignorehitpause = 1
flag = noBG
flag2 = noFG
;flag3 = globalnoshadow

[State 0, DestroySelf]
type = DestroySelf
triggerall = !winko
trigger1 = time
trigger1 = !numexplod(2995)

[State 0, VarSet]
type = VarSet
triggerall = fvar(14) < 1
trigger1 = fvar(14) > 0
trigger2 = root,stateno = 3000 || root,stateno = 3100 || root,stateno = 3200 || root,stateno = 3300 || root,stateno = 3400 || root,stateno = 3500
trigger2 = root,time = 1
fvar(14) = ifelse(fvar(14)+0.07>=1,1,fvar(14)+0.07)

[State 0, PalFXWiz]
type = PalFX
trigger1 = fvar(14) > 0
time = 2
mul = 256-ceil(256*fvar(14)),256,256-ceil(256*fvar(14))
sinadd = 0,0,0,1
invertall = 0
color = 256-ceil(224*fvar(14))

;---------------------------------------------------------------------------
; Hyper KO BG
[Statedef 2992]
type    = A
movetype= I
physics = N
ctrl = 0
anim = 9741
sprpriority = 5
velset = 0,0

[State 0, PlaySnd]
type = PlaySnd
trigger1 = time = 0
value = S0,36
abspan = 0

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(2995)
id = 2995
ignorehitpause = 1

[State 0, Explod]
type = Explod
trigger1 = time = 0
anim = 2996
ID = 2996
pos = 0,0-(240-gameheight)
postype = left
facing = 1
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = -2
scale = 1,1
sprpriority = -999
ontop = 0
shadow = 0,0,0
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = time < 127
ignorehitpause = 1
flag = noBG
flag2 = noFG
flag3 = globalnoshadow

[State 0, VarSet]
type = VarSet
trigger1 = time = 0
fvar(2) = 1
[State 0, VarSet]
type = VarSet
trigger1 = time >= 128
fvar(2) = ifelse(fvar(2)*0.9<0.05,0,fvar(2)*0.9)
[State 0, BGPalFX]
type = BGPalFX
trigger1 = fvar(2) > 0
time = 2
add = ceil(256*fvar(2)),ceil(256*fvar(2)),ceil(256*fvar(2))
mul = 256+ceil(256*fvar(2)),256+ceil(256*fvar(2)),256+ceil(256*fvar(2))
ignorehitpause = 1

;---------------------------------------------------------------------------
; It Had to happen
[Statedef 2993]
type    = A
movetype= I
physics = N
ctrl = 0
anim = 9741
sprpriority = 5
velset = 0,0

[State 0, EnvShake]
type = EnvShake
trigger1 = time = 1
time = 8
freq = 253
ampl = -4
ignorehitpause = 1

[State 0, StopSnd]
type = StopSnd
trigger1 = time = 1
channel = -1
ignorehitpause = 1
[State 0, PlaySnd]
type = PlaySnd
trigger1 = time = 1
value = S666,0
abspan = 0

[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(2995)
id = 2995
ignorehitpause = 1
[State 0, RemoveExplod]
type = RemoveExplod
trigger1 = numexplod(2912)
id = 2912
ignorehitpause = 1


[State 0, Explod]
type = Explod
trigger1 = time = 1
anim = 666
ID = 2666
pos = 160,floor(gameheight/2)
postype = left
facing = 1
vfacing = 1
bindtime = -1
vel = 0,0
accel = 0,0
random = 0,0
removetime = 100
scale = 1,1
sprpriority = 999
ontop = 1
shadow = 0,0,0
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, EnvColor]
type = EnvColor
trigger1 = numexplod(2666)
value = 0,0,0
time = 1
ignorehitpause = 1

[State 0, SuperPause]
type = SuperPause
trigger1 = numexplod(2666)
time = 2
movetime = 2
anim = -1
sound = -1
pos = 0,0
darken = 0
p2defmul = 1
unhittable = 1
pausebg = 1
ignorehitpause = 1


[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = numexplod(2666)
;trigger1 = time < 100
ignorehitpause = 1
flag = nobardisplay
flag2 = noFG
flag3 = noFG

[State 0, AssertSpecial]
type = AssertSpecial
trigger1 = time >= 0
;trigger1 = time < 100
ignorehitpause = 1
flag = nomusic
flag2 = nokosnd
flag3 = nokoslow


;---------------------------------------------------------------------------
; States that are always executed (use statedef -2)
;---------------------------------------------------------------------------

[Statedef -2]

; if you're making a 10ov.st and copied the statedef -2 in it's entirety, uncomment this strcl so e.g. the hitpauses in both mugen versions would be the same
[State ME AM USING 1.0]
type = VarSet
trigger1 = var(49) != 1
var(49) = 1
ignorehitpause = 1

[State X-Factor Chip Negation]
type = LifeAdd
triggerall = numhelper(722)
triggerall = helper(722),stateno = 722
trigger1 = gethitvar(damage) > 0
trigger1 = stateno = [150,157]
value = gethitvar(damage)
kill = 0
absolute = 0
ignorehitpause = 1
[State X-Factor Healing factor]
type = LifeAdd
triggerall = numhelper(722)
triggerall = helper(722),stateno = 722
trigger1 = helper(722),time%12=0
trigger1 = movetype != H
trigger1 = stateno != [120,156]
value = 1
kill = 0
absolute = 1
ignorehitpause = 1

[State 0, Collapse turn]
type = Turn
trigger1 = anim = 5950 || anim = 5955
trigger1 = animelem = 3
trigger2 = anim = 5915
trigger2 = animelem = 2

[State 0, Collapse]
type = PlaySnd
trigger1 = anim = 5950 || anim = 5955
trigger1 = animelem = 3
trigger2 = anim = 5915
trigger2 = animelem = 2
value = S7,0

[State 0, Collapse]
type = PlaySnd
trigger1 = anim = 5950 || anim = 5955
trigger1 = animelem = 9
trigger2 = anim = 5915
trigger2 = animelem = 7
value = S7,1


[State 0, Collapse]
type = PlaySnd
triggerall = !alive
trigger1 = anim = 5950 || anim = 5955
trigger1 = animelem = 3
trigger2 = anim = 5915
trigger2 = animelem = 2
value = S5300,0
channel = 0

[State 0, Soundskipper]
type = VarAdd
trigger1 = roundstate >= 2
trigger1 = var(41) < 7
var(41) = 1
ignorehitpause = 1
[State 0, StopSnd]
type = StopSnd
trigger1 = roundstate >= 2
trigger1 = var(41) = 2
channel = 6

[State 0, LiftReset]
type = VarSet
triggerall = var(40)
triggerall = var(21) != 1
trigger1 = !numtarget
trigger2 = numtarget
trigger2 = target,statetype=A
var(40) = 0
ignorehitpause = 1

[State 0, Prepare Ofscreen Mode]
type = VarSet
triggerall = var(45)=1
trigger1 = backedgebodydist <= 50*const(size.xscale)
;trigger2 = frontedgedist <= -64*const(size.xscale)
;trigger3 = screenpos y < 0
;trigger4 = screenpos y >= 440
var(45) = 2
ignorehitpause = 1
[State 0, Go Offscreeen]
type = ScreenBound
trigger1 = var(45)>=2
value = 0
movecamera = 0,0
ignorehitpause = 1
[State 0, Turn On Actually Ofscreen Mode]
type = VarSet
triggerall = var(45)>=2
trigger1 = backedgedist <= -64*const(size.xscale)
;trigger2 = frontedgedist <= -64*const(size.xscale)
;trigger3 = screenpos y < 0
;trigger4 = screenpos y >= 440
var(45) = 3
ignorehitpause = 1
[State 0, Turn Justin Case]
type = VarSet
triggerall = var(45)>=2
trigger1 = backedgebodydist > 8*const(size.xscale)
trigger1 = frontedgebodydist > 8*const(size.xscale)
;trigger3 = screenpos y < 0
;trigger4 = screenpos y >= 440
var(45) = ifelse(stateno=100,0,1)
ignorehitpause = 1
[State 0, Turn Off Ofscreen Mode]
type = VarSet
triggerall = var(45)>0
trigger1 = ctrl
trigger1 = var(45)!=1
trigger2 = stateno = 52
trigger3 = movetype = H
var(45) = 0
ignorehitpause = 1

[State 0, VarSet]
type = VarSet
triggerall = var(30) = 0
triggerall = numenemy
trigger1 = (gethitvar(hitcount)>=1) ;(enemy,movecontact >= 1 || enemy,projcontact >= 1) && (!enemy,moveguarded)
var(30) = -1
ignorehitpause = 1
;[State 0, PowerAdd]
;type = PowerAdd
;triggerall = var(30) = 0
;triggerall = stateno != [3000,3999]
;trigger1 = (movecontact >= 1 || projcontact >= 1) && (!moveguarded)
;trigger2 = projhittime = 0
;trigger2 = p2movetype = H
;trigger2 = movetype = A
;trigger2 = p2stateno != [120,169]
;trigger2 = projhittime = 1
;value = 150
;ignorehitpause = 1
[State -2 Send the message]
type = Varset
triggerall = var(30) = 0
triggerall = numenemy
trigger1 = (enemynear,gethitvar(hitcount)>=1);(movecontact >= 1 || projcontact >= 1) && (!moveguarded)
;trigger2 = p2movetype = H
;trigger2 = movetype = A
;trigger2 = p2stateno != [120,169]
;trigger2 = projhittime = 1
var(37) = var(37) | floor(exp(2*ln(2)) + 0.5)
ignorehitpause = 1
[State 0, VarSet]
type = VarSet
triggerall = var(30) = 0
triggerall = numenemy
trigger1 = (enemynear,gethitvar(hitcount)>=1);(movecontact >= 1 || projcontact >= 1) && (!moveguarded)
;trigger2 = p2movetype = H
;trigger2 = movetype = A
;trigger2 = p2stateno != [120,169]
;trigger2 = projhittime = 1
var(30) = 1
ignorehitpause = 1

[State -2, Movehitoner]
type = VarSet
trigger1 = numenemy
var(21) = ifelse(movehit=1&&(enemynear,movereversed!=[1,2]),var(21)+1,0)
ignorehitpause = 1
[State -2, Movehitoner]
type = VarSet
trigger1 = !numenemy
var(21) = ifelse(movehit=1,var(21)+1,0)
ignorehitpause = 1
[State -2, Moveguardoner]
type = VarSet
trigger1 = 1
var(22) = ifelse(moveguarded=1,var(22)+1,0)
ignorehitpause = 1
[State -2, FirstHit]
type = VarSet
trigger1 = 1
var(29) = 0
ignorehitpause = 1
[State -2, FirstHit]
type = VarSet
trigger1 = var(21)=1
trigger1 = numtarget
trigger1 = p2stateno != [120,169]
var(29) = (target,gethitvar(hitcount) <= 1)
ignorehitpause = 1

[State -2, Counter?]
type = VarSet
trigger1 = var(21) != 1
var(31) = (p2movetype=A)
ignorehitpause = 1
[State -2 Send the message]
type = Varset
trigger1 = !enemynear,movereversed
trigger1 = var(31) = 1
trigger1 = var(21) = 1
var(37) = var(37) | floor(exp(0*ln(2)) + 0.5)
ignorehitpause = 1
;[State 0, PlaySnd]
;type = PlaySnd
;trigger1 = !enemynear,movereversed
;trigger1 = var(31) = 1
;trigger1 = var(21) = 1
;value = S209,random%10
;channel = 0
;lowpriority = 1
;ignorehitpause = 1

;[State P2Soundcode nope]
;type = VarSet
;trigger1 = 1
;var(33) = 0
;ignorehitpause = 1
;[State P2Soundcode WHAM]
;type = VarSet
;trigger1 = (numtarget)
;trigger1 = (target,stateno = 227)
;trigger1 = (target,time = 1)
;trigger1 = (target,movetype = H)
;var(33) = 1
;ignorehitpause = 1


[State Throw Limiter]
type = VarSet
trigger1 = stateno = 40
trigger2 = statetype = A
trigger2 = movecontact
trigger3 = p2stateno = [120,169]
var(8) = 12
[State Throw Limiter count]
type = VarAdd
trigger1 = var(8) > 0
var(8) = -1
[State 0, Helper]
type = Helper
trigger1 = roundstate < 2
trigger1 = !numhelper(444)
helpertype = normal
name = "CONFIG"
ID = 444
stateno = 444
pos = 444,444
postype = p1
facing = 1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, ]
type = PlaySnd
triggerall = alive
;triggerall = random < 500
;triggerall = anim != 70851
trigger1 = (stateno = 5001) || (stateno = 5011) || (stateno = 5021) || (stateno = 5070)
trigger1 = time = 1
trigger2 = (stateno != [5000,5001]) && (stateno != [5010,5011]) && (stateno != [5020,5021]) && (stateno != 5070)
trigger2 = stateno != [120,160]
trigger2 = gethitvar(damage)
value = 5000,random%6
;volume = 255
channel = 0
ignorehitpause = 1

[State 0, ]
type = PlaySnd
trigger1 = anim = 5300
trigger1 = time = 1
value = 5300,0
channel = 0
;volume = 255

[State 0, Helper]
type = Helper
triggerall = !ishelper
trigger1 = !numhelper(179)
helpertype = normal
name = "Misc Stuff"
ID = 179
stateno = 179
pos = 0,0
postype = p1
ownpal = 1
supermovetime = 65535
pausemovetime = 65535
ignorehitpause = 1

[State 0, Factor Countdown]
type = VarSet
trigger1 = fvar(16) > 0
fvar(16) = fvar(16) - 1
ignorehitpause = 1
[State 0, No Factor]
type = VarSet
trigger1 = time >= 0
fvar(15) = 0
ignorehitpause = 1
[State 0, X-Factor]
type = VarSet
trigger1 = numhelper(722)
trigger1 = helper(722),stateno = 722
fvar(15) = 0.4 + (0.1*(helper(722),var(0)))
ignorehitpause = 1
[State Prevent the prorator from going too low. You can change the minimal proration rate if you want, just make sure the value in the trigger and actual varset match]
type = VarSet
trigger1 = fvar(13) < 0.15
fvar(13) = 0.15
ignorehitpause = 1
[State X-Factor Minimum proration]
type = VarSet
trigger1 = numhelper(722)
trigger1 = helper(722),stateno = 722
trigger1 = fvar(13) < 0.65
fvar(13) = 0.65
ignorehitpause = 1
[State Prorator Reset]
type = VarSet
trigger1 = !numenemy
trigger2 = p2movetype != H || (!enemynear,gethitvar(hitcount))
trigger2 = !movehit || movereversed
trigger3 = p2stateno = 5120
fvar(13) = 1+fvar(15)
ignorehitpause = 1
;[State X-Factor Prorator Reset]
;type = VarSet
;triggerall = numhelper(722)
;triggerall = helper(722),stateno = 722
;trigger1 = !numenemy
;trigger2 = p2movetype != H || (!enemynear,gethitvar(hitcount))
;trigger2 = !movehit || movereversed
;trigger3 = p2stateno = 5120
;fvar(13) = 1+fvar(15)
;ignorehitpause = 1
[State 0, AttackMulSet]
type = AttackMulSet
trigger1 = 1
time = 2
;value = ifelse(p2movetype!=H,ifelse(var(20)=1,1.25,1),1 - ifelse(fvar(15)>.75,.75,fvar(15)))
;value = ( ifelse((stateno=[3000,3900]), 0.25+(fvar(13)*0.75) ,fvar(13))  ) * ifelse((p2statetype=A&&p2movetype!=H)||var(31),1.25,1)
value = ( ifelse((stateno=[3000,3900]), 0.25+(fvar(13)*0.75) ,fvar(13))  ); * ifelse(var(31),1.25,1)
ignorehitpause = 1




;
; Within StateDef -2, none of your own AI-related code should be placed
; above these next two controllers.

[State -2, StopAI]
type = VarSet
triggerall = var(58) > 0 && !IsHelper
trigger1 = RoundState != 2
trigger2 = !Alive
var(58) = -2
IgnoreHitPause = 1

; This controller is optional.  It allows you treat the AI flag as a boolean
; value rather than an integer value, letting you trigger your AI directives
; with "var(0)" instead of "var(58)>0", and letting you make moves usable only
; by humans by using "!var(0)" instead of "var(58)<1", thus slightly improving
; the size and efficiency of your code.
; Another benefit is that it makes it much easier for users to disable your AI,
; if they so choose.
[State -2, Scaler]
type = VarSet
trigger1 = time = 0
fvar(36) = roundno + matchno*3
IgnoreHitPause = 1
[State -2, TOO MUCH]
type = VarSet
trigger1 = fvar(36) >= 80
fvar(36) = 80
IgnoreHitPause = 1
[State -2, Simplifier]
type = VarSet
;triggerall = !IsHelper
;trigger1 = var(58) = 1
;trigger2 = fvar(35):=0
trigger1 = !ishelper
fvar(35) = ifelse((roundstate=2&&ailevel>=1),ailevel+fvar(36),0)
IgnoreHitPause = 1

[State ANTI-MINDGAME-GUARD]
type = VarAdd
triggerall = var(50) < 120
trigger1 = p2movetype = A
trigger1 = stateno = [120,169]
var(50) = 1
ignorehitpause = 1
[State ANTI-MINDGAME-GUARD]
type = VarSet
triggerall = var(50) > 0
trigger1 = stateno = [150,155]
trigger1 = time = 1
var(50) = ceil(var(50)*0.8)
ignorehitpause = 1
[State ANTI-MINDGAME-GUARD]
type = VarAdd
triggerall = var(50) > 0
triggerall = (gametime%3)=0
trigger1 = p2movetype != A
trigger2 = stateno != [120,169]
var(50) = -1
ignorehitpause = 1
[State ANTI-MINDGAME-TH]
type = VarSet
trigger1 = numenemy
trigger1 = fvar(35)
var(51) = (enemynear,HitDefAttr = SCA,AT) || (var(50) > 20) || ((abs(enemynear,animtime) <= enemynear,moveguarded )) || (numhelper(3050))
ignorehitpause = 1

[state -2, AI Detect Projectile System]
type = helper
trigger1 = ailevel ;M.U.G.E.N 1.0+
trigger1 = !numhelper(33333333)
name = "AI Detect Projectile System"
ID = 33333333
stateno = 33333333
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 2147483647
pausemovetime = 2147483647
ignorehitpause = 1

;================================================================================
; ------- KOF Cornerpush System by Vans --------
;===============================================================================
[State -2, Superpause Check]
type = VarAdd
trigger1 = Var(6)
var(6) = -1

[State -2, Reset Time counter]
type = VarSet
trigger1 = movecontact = 1
var(12) = 0

[State -2, Accel]
type = VarSet
triggerall = roundstate = 2
triggerall = Var(6) <= 0
triggerall = numtarget >= 1
trigger1 = target, hitshakeover
fvar(6) = (target, gethitvar(xvel)*exp((-0.1886)*((var(12)))))
[State -2, Push]
type = PosAdd
triggerall = roundstate = 2
triggerall = !var(6)
triggerall = numtarget >= 1
triggerall = (target, BackEdgeBodyDist <= 0) || (target, FrontEdgeBodyDist <= 0)
triggerall = ProjContact = 0, < 50
triggerall = stateno != [800,899]
;triggerall = stateno != [10800,10899]
;triggerall = stateno != 2400
;triggerall = enemynear,statetype != A
;triggerall = enemynear,statetype != L
trigger1 = Statetype != A
x = ifelse(facing = -1,fvar(6),-fvar(6))

[State -2, Increase]
type = VarSet
triggerall = Var(6) <= 0
triggerall = var(12)
trigger1 = numtarget >= 1
trigger1 = target, hitshakeover
var(12) = var(12)+1

[State -2, Time counter]
type = VarSet
trigger1 = !var(12)
trigger1 = fvar(6)
var(12) = 1

[State -2, Freeze Pos During Superpause]
type = PosFreeze
trigger1 = Var(6)
value = 1

[State -2, Drop]
type = VarSet
triggerall = fvar(6)
trigger1 = !numtarget
trigger2 = projcontact = 1
trigger3 = movecontact = 1
fvar(6) = 0
ignorehitpause = 1

[State -2, Drop]
type = VarSet
triggerall = fvar(8)
trigger1 = !numtarget
trigger2 = projcontact = 1
trigger3 = numtarget >= 1 && target, gethitvar(xvel) = 0
var(17) = 0
